void handleMsgActions(string message,string action,string nickName,string ident,string command,string args,int omnom) {
	int id;
	string send = "";
	if (command=="help") {
		send = "\0034\xf\002"+help(args);
	}
	if (command=="new") {
		command = args.substr(0,args.find(" "));
		args = args.substr(args.find(" ")+1);
		if (command=="user") {
			if ((id=isLoggedIn(ident))==-1) {
				string username = args.substr(0,args.find(" "));
				string passwd = args.substr(args.find(" ")+1);
				if (passwd.find(" ")!=string::npos)
					passwd = passwd.substr(0,passwd.find(" "));
				if (valid(username) && (id = newUser(username,passwd,ident,nickName,omnom))!=-1)
					send = "\0034\xf\002User \002"+username+"\002 created. You are logged in.";
				else
					send = "\0034\xf\002\002ERROR\002: User already exists or is invalid.";
			} else
				send = "\0034\xf\002\002ERROR\002: You are already logged in as \002"+users[id].username+"\002";
		}
	}
	if (command=="login") {
		if ((id=isLoggedIn(ident))==-1) {
			string username = args.substr(0,args.find(" "));
			string passwd = args.substr(args.find(" ")+1);
			if (passwd.find(" ")!=string::npos)
				passwd = passwd.substr(0,passwd.find(" "));
			if ((id=login(username,passwd,ident,nickName,omnom))!=-1) {
				send = "\0034\xf\002You are now logged in as \002"+users[id].username+"\002";
				if (mafia.inGame && users[id].gameJoined && !users[id].dead) {
					send += ". You are "+users[id].role;
					if (mafia.step==1)
						send += ". It is night";
					if (mafia.step==2)
						send += ". It is day";
					if (users[id].mafia == true && !users[id].voted && mafia.step == 1 && !users[id].dead && users[id].role!="Terrorist") {
						vector<string> otherMafiaUsers = usersMafia();
						string resultMafiausers;
						for (int i=0;i<otherMafiaUsers.size();i++)
							resultMafiausers += otherMafiaUsers[i]+",";
						if (users[id].omnom != 2)
							send += ". Vote for someone who should be killed with /msg "+efnet.nick+" vote <name>. All mafia people: "+
						        resultMafiausers.substr(0,resultMafiausers.size()-1);
						else
							send += ". Vote for someone who should be killed with /msg sorunome vote <name>. All mafia people: "+
						        resultMafiausers.substr(0,resultMafiausers.size()-1);
					}
					if (users[id].role=="Doctor" && !users[id].voted && mafia.step==1 && !users[id].dead) {
						if (users[id].omnom != 2)
							send += ". Save someone from death by typing /msg "+efnet.nick+" save <name>";
						else
							send += ". Save someone from death by typing /msg sorunome save <name>";
					}
					if (users[id].role=="Detective" && !users[id].voted && mafia.step==1 && !users[id].dead) {
						if (users[id].omnom != 2)
							send += ". Check out the role of someone by typing /msg "+efnet.nick+" role <name>.";
						else
							send += ". Check out the role of someone by typing /msg sorunome role <name>.";
					}
					if (users[id].role=="Matchmaker" && !users[id].voted && mafia.step==1 && !users[id].dead) {
						if (users[id].omnom != 2)
							send += ". Check if two people are in the same group by typing /msg "+efnet.nick+" match <user1> <user2>.";
						else
							send += ". Check if two people are in the same group by typing /msg sorunome match <user1> <user2>.";
					}
					if (users[id].role=="Fool" && !users[id].dead) {
						if (mafia.foolSharpend)
							send += ". You are sharpened.";
						else
							send += ". You are not sharpened.";
					}
					if (!users[id].voted && mafia.step==2 && !users[id].dead)
						send += ". Vote for someone who shall be killed with \">vote <name>\"";
				}
			} else
				send = "\0034\xf\002\002ERROR\002: Username or password is wrong.";
		} else
			send = "\0034\xf\002\002ERROR\002: You are already logged in as \002"+users[id].username+"\002";
	}
	if (command=="set") {
		if ((id=isLoggedIn(ident))!=-1) {
			command = args.substr(0,args.find(" "));
			args = args.substr(args.find(" ")+1);
			if (command=="password") {
				string oldpasswd = args.substr(0,args.find(" "));
				string newpasswd = args.substr(args.find(" ")+1);
				if (md5(oldpasswd)==users[id].password) {
					users[id].password = md5(newpasswd);
					send = "\0034\xf\002Password changed.";
				} else
					send = "\0034\xf\002\002ERROR\002: Password is incorrect.";
			}
			if (command=="username") {
				if (args.find(" ")!=string::npos)
					args = args.substr(0,args.find(" "));
				if (whoisirc(args)==-1 && valid(args)) {
					users[id].username = args;
					send = "\0034\xf\002Username changed to "+users[id].username;
				} else
					send = "\0034\xf\002\002ERROR\002: Username already exists or is invalid.";
			}
			if (command=="admin" && users[id].right!=0) {
				command = args.substr(0,args.find(" "));
				args = args.substr(args.find(" ")+1);
				if (args.find(" ")!=string::npos)
					args = args.substr(0,args.find(" "));
				int id2 = whoisirc(args);
				if (id2!=-1) {
					if (command=="true") {
						if (users[id2].right!=2) {
							users[id2].right = 1;
							send = "\0034\xf\002User "+users[id2].username+" is now admin";
						} else
							send = "\0034\xf\002\002ERROR\002: You can't change the rights of the owner.";
					}
					if (command=="false") {
						if (users[id2].right!=2) {
							users[id2].right = 0;
							send = "\0034\xf\002User "+users[id2].username+" is not more admin";
						} else
							send = "\0034\xf\002\002ERROR\002: You can't change the rights of the owner.";
					}
				} else
					send = "\0034\xf\002\002ERROR\002: User not found.";
			}
		} else
			send = "\0034\xf\002\002ERROR\002: You are not logged in.";
	}
	if (command=="logout") {
		if ((id=isLoggedIn(ident))!=-1) {
			logout(ident);
			send = "\0034\xf\002You are now logged out.";
		} else
			send = "\0034\xf\002\002ERROR\002: You are not logged in.";
	}
	if (command=="whois") {
		if (args.find(" ")!=string::npos)
			args = args.substr(0,args.find(" "));
		if ((id=whois(args))!=-1)
			send = "\0034\xf\002IRC user "+users[id].nickOnIRC+" is "+users[id].username;
		else
			send = "\0034\xf\002\002ERROR\002: User does not exist.";
	}
	if (command=="whoisirc") {
		if (args.find(" ")!=string::npos)
			args = args.substr(0,args.find(" "));
		if ((id=whoisirc(args))!=-1)
			send = "\0034\xf\002User "+users[id].username+" is on IRC "+users[id].nickOnIRC;
		else
			send = "\0034\xf\002\002ERROR\002: User does not exist.";
	}
	if (command=="whoami" && (id=isLoggedIn(ident))!=-1 && mafia.inGame) {
		if (users[id].gameJoined) {
			if (!users[id].dead)
				send = "\0034\xf\002You are "+users[id].role;
			else
				send = "\0034\xf\002You are dead";
		}
	}
	if (command=="users") {
		vector<string> usersJoined = usersJoinedGame();
		string usersJoinedString;
		for (int i=0;i<usersJoined.size();i++)
			usersJoinedString += usersJoined[i]+", ";
		send = "\0034\xf\002"+toString(usersJoined.size())+" Users joined: "+usersJoinedString.substr(0,usersJoinedString.size()-1);
	}
	if ((command=="vote" || command=="kill") && (id=isLoggedIn(ident))!=-1 && mafia.step==1) {
		if (users[id].mafia && users[id].gameJoined && !users[id].dead && users[id].role!="Terrorist") {
			if (!users[id].voted) {
				if (args.find(" ")!=string::npos)
					args = args.substr(0,args.find(" "));
				int id2;
				if ((id2=whoisirc(args))!=-1) {
					if (users[id2].gameJoined && !users[id2].dead) {
						users[id2].votes++;
						users[id].voted = true;
						for (int i=0;i<users.size();i++)
							if (users[i].gameJoined && users[i].mafia)
								sendPmToUser(users[i].omnom,users[i].nickOnIRC,users[id].username+" voted for "+users[id2].username+
								             ". His current votes are "+toString(users[id2].votes));
						if (mafia.allMafiaVoted())
							mafia.nextStep();
					} else
						send = "\0034\xf\002\002ERROR\002: User does not play.";
				} else
					send = "\0034\xf\002\002ERROR\002: User does not exist.";
			} else
				send = "\0034\xf\002\002ERROR\002: You already voted.";
		}
	}
	if (command=="save" && (id=isLoggedIn(ident))!=-1 && mafia.step==1) {
		if (users[id].role=="Doctor" && users[id].gameJoined && !users[id].dead) {
			if (!users[id].voted) {
				if (args.find(" ")!=string::npos)
					args = args.substr(0,args.find(" "));
				int id2;
				if ((id2=whoisirc(args))!=-1) {
					if (users[id2].gameJoined && !users[id2].dead) {
						mafia.save = id2;
						users[id].voted = true;
						send = "\0034\xf\002You saved "+users[id2].username+".";
						sendPmToUser(omnom,nickName,send);
						send = "";
						if (mafia.allMafiaVoted())
							mafia.nextStep();
					} else
						send = "\0034\xf\002\002ERROR\002: User does not play.";
				} else
					send = "\0034\xf\002\002ERROR\002: User does not exist.";
			} else
				send = "\0034\xf\002\002ERROR\002: You already saved someone.";
		}
	}
	if ((command=="role" || command=="check" || command=="spy") && (id=isLoggedIn(ident))!=-1 && mafia.step==1) {
		if (users[id].role=="Detective" && users[id].gameJoined && !users[id].dead) {
			if (!users[id].voted) {
				if (args.find(" ")!=string::npos)
					args = args.substr(0,args.find(" "));
				int id2;
				if ((id2=whoisirc(args))!=-1) {
					if (users[id2].gameJoined && !users[id2].dead) {
						users[id].voted = true;
						if (users[id2].seemMafia)
							send = "\0034\xf\002"+users[id2].username+" is for mafia.";
						else
							send = "\0034\xf\002"+users[id2].username+" is for citizen.";
						sendPmToUser(omnom,nickName,send);
						send = "";
						if (mafia.allMafiaVoted())
							mafia.nextStep();
					} else
						send = "\0034\xf\002\002ERROR\002: User does not play.";
				} else
					send = "\0034\xf\002\002ERROR\002: User does not exist.";
			} else
				send = "\0034\xf\002\002ERROR\002: You already revieled the identity of someone.";
		}
	}
	if (command=="match" && mafia.step==1 && (id=isLoggedIn(ident))!=-1 && users[id].role=="Matchmaker" && users[id].gameJoined && !users[id].dead) {
		if (!users[id].voted) {
			if (args.find(" ")!=string::npos) {
				int id2 = whoisirc(args.substr(0,args.find(" ")));
				args = args.substr(args.find(" ")+1);
				if (args.find(" ")!=string::npos)
					args = args.substr(0,args.find(" "));
				int id3 = whoisirc(args);
				if (id2!=-1 && id3!=-1) {
					if (users[id2].seemMafia==users[id3].seemMafia)
						send = "\0034\xf\002They are in the same group.";
					else
						send = "\0034\xf\002They are not in the same group.";
					sendPmToUser(omnom,nickName,send);
					send = "";
					users[id].voted = true;
					if (mafia.allMafiaVoted())
						mafia.nextStep();
				} else
					send = "\0034\xf\002\002ERROR\002: Not all users exist.";
			} else
				send = "\0034\xf\002\002ERROR\002: You need to enter two people.";
		} else
			send = "\0034\xf\002\002ERROR\002: You already matched two people.";
	}
	if (command=="votes" &&  (id=isLoggedIn(ident))!=-1 && mafia.inGame && mafia.step==1) {
		if (users[id].gameJoined && users[id].mafia && !users[id].dead) {
			if (args.find(" ")!=string::npos)
				args = args.substr(0,args.find(" "));
			int id2;
			if ((id2=whoisirc(args))!=-1) {
				if (users[id2].gameJoined && !users[id2].dead)
					send = "\0034\xf\002User "+users[id2].username+" has "+toString(users[id2].votes)+" votes";
				else
					send = "\0034\xf\002\002ERROR\002: user does not play.";
			} else
				send = "\0034\xf\002\002ERROR\002: User does not exist.";
		}
	}
	data.open("usersMafia.txt", ios::out);
	writeData(&data);
	data.close();
	if (send!="")
		sendPmToUser(omnom,nickName,send);
}
