void handleNormalActions(string message,string action,string nickName,string ident,string command,string args,string postChannel,int omnom) {
	int id;
	id=isLoggedIn(ident);
	string send = "";
	if (command==">help") {
		send = "PRIVMSG "+postChannel+" :\0034\xf\002"+help(args)+"\n";
	}
	if (command==">about") {
		send = "PRIVMSG "+postChannel+" :\0034\xf\002MafiaBot created by Sorunome. http://www.sorunome.de\n";
	}
	if (command==">specialCharacters" || command==">specialRoles" || command==">specialUsers") {
		if (mafia.inGame)
			send = "PRIVMSG "+postChannel+" :\0034\xf\002Special characters using:"+mafia.specialUsers.substr(0,mafia.specialUsers.size()-2)+"\n";
		else
			send = "PRIVMSG "+postChannel+" :\0034\xf\002Special characters available: detective, doctor, justin, hunter, gardener, fool, freemason, matchmaker, terrorist, godfather\n";
	}
	if (command==">join" && !mafia.inGame) {
		if (id!=-1) {
			if (!users[id].gameJoined) {
				users[id].gameJoined = true;
				send = "PRIVMSG "+postChannel+" :\0034\xf\002You now joined THE GAME\n";
			} else
				send = "PRIVMSG "+postChannel+" :\0034\xf\002\002ERROR\002: You have already joined.\n";
		} else
			send = "PRIVMSG "+postChannel+" :\0034\xf\002\002ERROR\002: You are not logged in.\n";
	}
	if (command==">leave" && !mafia.inGame) {
		if (id!=-1) {
			if (users[id].gameJoined) {
				users[id].gameJoined = false;
				send = "PRIVMSG "+postChannel+" :\0034\xf\002You now left THE GAME\n";
			} else
				send = "PRIVMSG "+postChannel+" :\0034\xf\002\002ERROR\002: You did not join a game.\n";
		} else
			send = "PRIVMSG "+postChannel+" :\0034\xf\002\002ERROR\002: You are not logged in.\n";
	}
	if (command==">whois") {
		if (args.find(" ")!=string::npos)
			args = args.substr(0,args.find(" "));
		if ((id=whois(args))!=-1)
			send = "PRIVMSG "+postChannel+" :\0034\xf\002IRC user "+users[id].nickOnIRC+" is "+users[id].username+"\n";
		else
			send = "PRIVMSG "+postChannel+" :\0034\xf\002\002ERROR\002: User does not exist.\n";
	}
	if (command==">whoisirc") {
		if (args.find(" ")!=string::npos)
			args = args.substr(0,args.find(" "));
		if ((id=whoisirc(args))!=-1)
			send = "PRIVMSG "+postChannel+" :\0034\xf\002User "+users[id].username+" is on IRC "+users[id].nickOnIRC+"\n";
		else
			send = "PRIVMSG "+postChannel+" :\0034\xf\002\002ERROR\002: User does not exist.\n";
	}
	if (command==">users") {
		vector<string> usersJoined = usersJoinedGame();
		string usersJoinedString;
		for (int i=0;i<usersJoined.size();i++)
			usersJoinedString += usersJoined[i]+", ";
		send = "PRIVMSG "+postChannel+" :\0034\xf\002"+toString(usersJoined.size())+" Users joined: "+usersJoinedString.substr(0,usersJoinedString.size()-2)+"\n";
	}
	if (command==">start" && id!=-1 && !mafia.inGame) {
		if (users[id].gameJoined) {
			vector<string> usersJoined = usersJoinedGame();
			if (usersJoined.size()>=4) {
				vector<string> specialUsers;
				if (args!=">start")
					args = toLower(args)+",";
				str_replace("det","detective",args);
				str_replace("doc","doctor",args);
				str_replace("jus","justin",args);
				str_replace("hun","hunter",args);
				str_replace("gar","gardener",args);
				str_replace("foo","fool",args);
				str_replace("fre","freemason",args);
				str_replace("ter","terrorist",args);
				str_replace("god","godfather",args);
				str_replace("mat","matchmaker",args);
				while (args.find(",")!=string::npos) {
					specialUsers.push_back(args.substr(0,args.find(",")));
					args = args.substr(args.find(",")+1);
				}
				int numberMafiaRequired=mafia.specialUsersValid(specialUsers);
				if ((numberMafiaRequired!=-1 && specialUsers.size()<usersJoined.size()) || specialUsers.size()==0) {
					for (int i=0;i<users.size();i++) { //machen dass users dinge leer sind
						users[i].mafia = false;
						users[i].seemMafia = false;
						users[i].role = "Citizen";
						users[i].voted = false;
						users[i].dead = false;
					}
					
					int numberMafiaSet = 0;
					string user;
					while (numberMafiaRequired>numberMafiaSet) { //mafia setzen
						user = usersJoined[rand()%usersJoined.size()];
						id = whoisirc(user);
						if (!users[id].mafia && users[id].gameJoined) {
							users[id].mafia = true;
							users[id].seemMafia = true;
							users[id].role = "Mafia";
							numberMafiaSet++;
						}
					}
					int numberSpecialUsersSet = 0;
					while (specialUsers.size()>numberSpecialUsersSet) { //special users setzen
						string user;
						user = usersJoined[rand()%usersJoined.size()];
						id = whoisirc(user);
						if (users[id].role=="Citizen" && specialUsers[numberSpecialUsersSet]=="detective") {
							users[id].role = "Detective";
							numberSpecialUsersSet++;
						}
						if (users[id].role=="Citizen" && specialUsers[numberSpecialUsersSet]=="doctor") {
							users[id].role = "Doctor";
							numberSpecialUsersSet++;
						}
						if (users[id].role=="Citizen" && specialUsers[numberSpecialUsersSet]=="justin") {
							users[id].role = "Justin";
							numberSpecialUsersSet++;
						}
                        if (users[id].role=="Citizen" && specialUsers[numberSpecialUsersSet]=="hunter") {
							users[id].role = "Hunter";
							numberSpecialUsersSet++;
						}
						if (users[id].role=="Citizen" && specialUsers[numberSpecialUsersSet]=="gardener") {
							users[id].role = "Gardener";
                            users[id].seemMafia = true;
							numberSpecialUsersSet++;
						}
                        if (users[id].role=="Citizen" && specialUsers[numberSpecialUsersSet]=="fool") {
							users[id].role = "Fool";
							numberSpecialUsersSet++;
						}
						if (users[id].role=="Citizen" && specialUsers[numberSpecialUsersSet]=="freemason") {
							users[id].role = "Freemason";
							numberSpecialUsersSet++;
						}
						if (users[id].role=="Citizen" && specialUsers[numberSpecialUsersSet]=="matchmaker") {
							users[id].role = "Matchmaker";
							numberSpecialUsersSet++;
						}
                        if (users[id].role=="Mafia" && specialUsers[numberSpecialUsersSet]=="terrorist") {
							users[id].role = "Terrorist";
							numberSpecialUsersSet++;
						}
                        if (users[id].role=="Mafia" && specialUsers[numberSpecialUsersSet]=="godfather") {
							users[id].role = "Godfather";
                            users[id].seemMafia = false;
							numberSpecialUsersSet++;
						}
					}
					mafia.mafianumber = numberMafiaSet;
					mafia.citizennumber = usersJoined.size()-numberMafiaSet;
					mafia.specialUsers = "";
					for (int i=0;i<specialUsers.size();i++)
						mafia.specialUsers += specialUsers[i]+",";
					mafia.save = -1;
					mafia.day = 0;
					mafia.step = 0;
					mafia.inGame = true;
					mafia.hunterDied = false;
					mafia.foolSharpend = false;
					efnet.sbuf2 = "PRIVMSG "+postChannel+" :\0034\xf\002The game started. Good luck everyone!\n";
					efnet.sendSbuf2();
					efnet.sbuf2 = "";
					pmUserRolls();
					mafia.nextStep();
					if (mafia.allMafiaVoted())
						mafia.nextStep();
				} else
					send = "PRIVMSG "+postChannel+" :\0034\xf\002\002ERROR\002: Special users set are invalid.\n";
			} else
				send = "PRIVMSG "+postChannel+" :\0034\xf\002\002ERROR\002: Not enough users have joined.\n";
		} else
			send = "PRIVMSG "+postChannel+" :\0034\xf\002\002ERROR\002: You are not part of the game.\n";
	}
	if (command==">time" || command==">wherearewe") {
		if (mafia.inGame) {
			if (mafia.step==1)
				send = "PRIVMSG "+postChannel+" :\0034\xf\002It is night.\n";
			if (mafia.step==2)
				send = "PRIVMSG "+postChannel+" :\0034\xf\002It is day.\n";
		} else
			send = "PRIVMSG "+postChannel+" :\0034\xf\002It is time to join the game.\n";
	}
	if ((command==">vote" || command==">kill") &&  id!=-1 && mafia.inGame && (mafia.step==2 || mafia.hunterDied)) {
		if ((users[id].gameJoined && !users[id].dead) || (users[id].role=="Hunter" && mafia.hunterDied)) {
			if (!users[id].voted) {
				if (args.find(" ")!=string::npos)
					args = args.substr(0,args.find(" "));
				int id2;
				if ((id2=whoisirc(args))!=-1) {
					if (users[id2].gameJoined && !users[id2].dead) {
						users[id2].votes++;
						users[id].voted = true;
						if (!mafia.hunterDied)
							efnet.sbuf2 = "PRIVMSG "+postChannel+" :\0034\xf\002Voted for "+users[id2].username+". His current vote-le"+
						        "vel is "+toString(users[id2].votes)+"\n";
						else
							efnet.sbuf2 = "PRIVMSG "+postChannel+" :\0034\xf\002You killed "+users[id2].username+". He was "+users[id2].role+"\n";
						efnet.sendSbuf2();
						efnet.sbuf2 = "";
						if (mafia.allVoted()) {
							mafia.nextStep();
							if (mafia.inGame && !mafia.hunterDied)
								mafia.nextStep();
							if (mafia.inGame && mafia.allMafiaVoted())
								mafia.nextStep();
						}
					} else
						send = "PRIVMSG "+postChannel+" :\0034\xf\002\002ERROR\002: User does not play.\n";
				} else
					send = "PRIVMSG "+postChannel+" :\0034\xf\002\002ERROR\002: User does not exist.\n";
			} else if (!mafia.hunterDied)
				send = "PRIVMSG "+postChannel+" :\0034\xf\002\002ERROR\002: You have already voted.\n";
		}
	}
	if (command==">votes" && id!=-1 && mafia.inGame && mafia.step==2) {
		if (args.find(" ")!=string::npos)
			args = args.substr(0,args.find(" "));
		int id2;
		if ((id2=whoisirc(args))!=-1) {
			if (users[id2].gameJoined && !users[id2].dead)
				send = "PRIVMSG "+postChannel+" :\0034\xf\002User "+users[id2].username+" has "+toString(users[id2].votes)+" votes\n";
			else
				send = "PRIVMSG "+postChannel+" :\0034\xf\002\002ERROR\002: User does not play.\n";
		} else
			send = "PRIVMSG "+postChannel+" :\0034\xf\002\002ERROR\002: User does not exist.\n";
	}
	if ((command==">explode" || command==">bomb") && !mafia.hunterDied && mafia.inGame && mafia.step==2 && id!=-1 && !users[id].dead &&
	        users[id].role=="Terrorist") {
		if (args.find(" ")!=string::npos)
			args = args.substr(0,args.find(" "));
		int id2 = whoisirc(args);
		if (id2!=-1) {
			send = "PRIVMSG "+postChannel+" :\0034\xf\002The terrorist bombed away "+users[id2].username+". He was "+users[id2].role+"\n";			
			efnet.sbuf2 = send;
			efnet.sendSbuf2();
			efnet.sbuf2 = "";
			send = "";
			mafia.killUser(id2);
			mafia.killUser(id);
			mafia.step = 0;
			if (mafia.inGame)
				mafia.nextStep();
		} else
			send = "PRIVMSG "+postChannel+" :\0034\xf\002\002ERROR\002: User does not exist.\n";
	}
	if ((command==">voted" || command==">whovoted") && mafia.inGame && mafia.step==2) {
		vector<string> usersVotedS = usersVoted();
		string usersVotedString;
		for (int i=0;i<usersVotedS.size();i++)
			usersVotedString += usersVotedS[i]+", ";
		send = "PRIVMSG "+postChannel+" :\0034\xf\002"+toString(usersVotedS.size())+" Users voted: "+usersVotedString.substr(0,usersVotedString.size()-2)+"\n";
		
	}
	if ((command==">notvoted" || command==">whonotvoted") && mafia.inGame && mafia.step==2) {
		vector<string> usersNotVotedS = usersNotVoted();
		string usersNotVotedString;
		for (int i=0;i<usersNotVotedS.size();i++)
			usersNotVotedString += usersNotVotedS[i]+", ";
		send = "PRIVMSG "+postChannel+" :\0034\xf\002"+toString(usersNotVotedS.size())+" Users not voted: "+usersNotVotedString.substr(0,usersNotVotedString.size()-2)+"\n";
	}
	if (command==">kick" && id!=-1 && !mafia.inGame) {
		if (users[id].right!=0) {
			if (args.find(" ")!=string::npos)
				args = args.substr(0,args.find(" "));
			int id2 = whoisirc(args);
			if (id2!=-1) {
				users[id2].gameJoined = false;
				send = "PRIVMSG "+postChannel+" :\0034\xf\002Removed "+users[id2].username+" from THE GAME\n";
			} else
				send = "PRIVMSG "+postChannel+" :\0034\xf\002\002ERROR\002: User does not exist.\n";
		} else
			send = "PRIVMSG "+postChannel+" :\0034\xf\002\002ERROR\002: You are no admin\n";
	}
	if (command==">quitgame" && id!=-1 && mafia.inGame) {
		if (users[id].right!=0) {
			mafia.victory(-1);
		} else
			send = "PRIVMSG "+postChannel+" :\0034\xf\002\002ERROR\002: You are no admin\n";
	}
	if (command==">thegame")
		send = "PRIVMSG "+postChannel+" :\0034\xf\002Wait, what did just happen? Right, you lost the game >.>\n";
	if (command==">derpy")
		send = "PRIVMSG "+postChannel+" :\0034\xf\002Derpy Hooves is best pony EVER!\n";
	if (send!="") {
		efnet.sbuf2 = send;
		efnet.sendSbuf2();
		efnet.sbuf2 = "";
	}
	data.open("usersMafia.txt", ios::out);
	writeData(&data);
	data.close();
}
