bool userExists(string username) {
	for (int i=0;i<users.size();i++)
		if (users[i].username==toLower(username))
			return true;
	return false;
}
int isLoggedIn(string ident) {
	for (int i=0;i<users.size();i++)
		if (users[i].ident==ident)
			return i;
	return -1;
}
int whois(string ircname) {
	for (int i=0;i<users.size();i++)
		if (users[i].nickOnIRC==toLower(ircname))
			return i;
	return -1;
}
int whoisirc(string username) {
	for (int i=0;i<users.size();i++)
		if (users[i].username==toLower(username))
			return i;
	return -1;
}
vector<string> usersJoinedGame() {
	vector<string> usersString;
	for (int i=0;i<users.size();i++)
		if ((users[i].gameJoined && !users[i].dead) || (!mafia.inGame && users[i].gameJoined))
			usersString.push_back(users[i].username);
	return usersString;
}
vector<string> usersVoted() {
	vector<string> usersString;
	for (int i=0;i<users.size();i++)
		if (users[i].gameJoined && !users[i].dead && users[i].voted)
			usersString.push_back(users[i].username);
	return usersString;
}
vector<string> usersNotVoted() {
	vector<string> usersString;
	for (int i=0;i<users.size();i++)
		if (users[i].gameJoined && !users[i].dead && !users[i].voted)
			usersString.push_back(users[i].username);
	return usersString;
}
vector<string> usersMafia() {
	vector<string> usersString;
	for (int i=0;i<users.size();i++)
		if (users[i].gameJoined && users[i].mafia && !users[i].dead && users[i].role!="Terrorist")
			usersString.push_back(users[i].username);
	return usersString;
}
vector<string> usersFreemason() {
	vector<string> usersString;
	for (int i=0;i<users.size();i++)
        if (users[i].gameJoined && users[i].role=="Freemason" && !users[i].dead)
			usersString.push_back(users[i].username);
	return usersString;
}
void logout(string ident) {
	for (int i=0;i<users.size();i++)
		if (users[i].ident==ident)
			users[i].ident = "";
}
int login(string username,string password,string ident,string nickName,int omnom) {
	for (int i=0;i<users.size();i++)
		if (users[i].username==toLower(username))
			if (users[i].password==md5(password)) {
				users[i].ident = ident;
				users[i].nickOnIRC = nickName;
				users[i].omnom = omnom;
				return i;
			}
	return -1;
}
int newUser(string username,string password,string ident,string nickName,int omnom) {
	int id = users.size(); //befor weil ja 0 und 1 unterschied
	if (!userExists(username))
		users.push_back(user(username,password,ident,nickName,omnom));
	else
		return -1;
	return id;
}
void pmUserRolls() {
	for (int i=0;i<users.size();i++)
		if (users[i].gameJoined)
			sendPmToUser(users[i].omnom,users[i].nickOnIRC,"\0034\xf\002"+help(users[i].role));
}

